zoukankan      html  css  js  c++  java
  • HDU3037 附Lucas简单整理

    Saving Beans

    Time Limit: 6000/3000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
    Total Submission(s): 4941    Accepted Submission(s): 1957


    Problem Description
    Although winter is far away, squirrels have to work day and night to save beans. They need plenty of food to get through those long cold days. After some time the squirrel family thinks that they have to solve a problem. They suppose that they will save beans in n different trees. However, since the food is not sufficient nowadays, they will get no more than m beans. They want to know that how many ways there are to save no more than m beans (they are the same) in n trees.

    Now they turn to you for help, you should give them the answer. The result may be extremely huge; you should output the result modulo p, because squirrels can’t recognize large numbers.
     
    Input
    The first line contains one integer T, means the number of cases.

    Then followed T lines, each line contains three integers n, m, p, means that squirrels will save no more than m same beans in n different trees, 1 <= n, m <= 1000000000, 1 < p < 100000 and p is guaranteed to be a prime.
     
    Output
    You should output the answer modulo p.
     
    Sample Input
    2 1 2 5 2 1 5
     
    Sample Output
    3 3
    Hint
    Hint For sample 1, squirrels will put no more than 2 beans in one tree. Since trees are different, we can label them as 1, 2 … and so on. The 3 ways are: put no beans, put 1 bean in tree 1 and put 2 beans in tree 1. For sample 2, the 3 ways are: put no beans, put 1 bean in tree 1 and put 1 bean in tree 2.
     
    Source
     
    Recommend
    gaojie   |   We have carefully selected several similar problems for you:  3033 3038 3036 3035 3034 


    题目大意:

    由n个不同的盒子,在每个盒子中放一些求(可以不放),使得总球数小雨等于m,求方案数(mod p).
    1<=n,m<=10^9,1<p<10^5,保证p是素数

    分析:
    设最后放了k个球,根据"隔板法"由方案数C(k+n-1,n-1),:
    ans=C(n-1,n-1)+C(n,n-1)+C(n+1,n-1)+……+C(n+m-2,n-1)+C(n+m-1,n-1)
         =C(n+m,n);(mod p)
    由于数据范围很大,C(n,m)=C(n-1,m)+C(n-1,m-1);显然会TLE
    最后组合数还要mod p,这时候 Lucas定理 闪亮登场
    ============================================
    Lucas定理(shenben简单总结版)
    ============================================
    Lucas定理1:
      Lucas(n,m,p)=cm(n%p,m%p)*Lucas(n/p,m/p,p);{其中cm(a,b)=C(a,b)%p;Lucas(x,0,p)=1;}
    Lucas定理2:
      把n写成p进制a[n]a[n-1]……a[0];
      把m写成p进制b[n]b[n-1]……b[0];(不够位数的话,显然前面是 0)
    则:C(a[n],b[n])*C(a[n-1],b[n-1])*……*C(a[0],b[0])
       =C(n,m) (mod p);
    ps:Lucas最大的数据处理能力是p在10^5左右。

    #include<cstdio>
    #include<iostream>
    using namespace std;
    typedef long long ll;
    const int N=1e5+5;
    ll n,m,p,a[N]={1};
    ll fpow(ll a,ll b){
        ll res=1;
        for(;b;b>>=1,a=a*a%p) if(b&1) res=res*a%p;
        return res;
    }
    ll C(ll n,ll m){
        if(m>n) return 0;
        return a[n]*fpow(a[m],p-2)%p*fpow(a[n-m],p-2)%p;
    }
    ll lucas(ll n,ll m){
        if(!m) return 1;
        return C(n%p,m%p)*lucas(n/p,m/p)%p;
    }
    int main(){
        int T;cin>>T;
        while(T--){
            cin>>n>>m>>p;
            for(int i=1;i<=p;i++) a[i]=a[i-1]*i%p;
            cout<<lucas(n+m,n)<<'
    ';
        }
        return 0;
    }
  • 相关阅读:
    Codeforces1420E. Battle Lemmings 题解 动态规划
    C++使用partial_sum求前缀和
    HDU6171 Admiral 题解 折半搜索
    HDU3017 Treasure Division 题解 折半搜索
    使用re.split 按标点+空格的一种分割办法
    实现CString的Format功能,支持跨平台
    转载一篇makefile,说的很详细
    Microsoft C++ 异常: std::system_error std::thread
    源码一样,运行结果不一致的解决办法
    记录一次阿里的电话面试
  • 原文地址:https://www.cnblogs.com/shenben/p/6529140.html
Copyright © 2011-2022 走看看